import { world, system } from "@minecraft/server"
import { hasEquipmentArtifact } from '../utils/functions.js'

const negativeEffects = [
    'hunger',
    'darkness',
    'blindness',
    'fatal_poison',
    'mining_fatigue',
    'nausea',
    'poison',
    'slowness',
    'wither',
    'weakness'
];

world.afterEvents.effectAdd.subscribe(ev => {
    let effect = ev.effect
    let entity = ev.entity

    try {
        if (entity.typeId != 'minecraft:player') { return }

        const legsEquipment = entity.getComponent('equippable').getEquipment('Legs')

        if (hasEquipmentArtifact(entity, legsEquipment, 'artifacts:antidote_vessel') && negativeEffects.includes(effect.typeId)) {
            system.runTimeout(() => {
                entity.removeEffect(effect.typeId)
            }, 20 * 5)
        }
    } catch { }

})

