import { world, system } from "@minecraft/server"
import { hasEquipmentArtifact } from '../utils/functions.js'


//Extraido de bedrock dev
function detectDoubleJumpEvent(callBack) {
    system.runInterval(() => {
        world.getAllPlayers().forEach(player => {
            // Initialize jump tracking if not set
            if (!player.hasOwnProperty("jumpCount")) player.jumpCount = 0;
            if (!player.hasOwnProperty("lastJumping")) player.lastJumping = false;

            // Reset jump count when touching the ground
            if (player.isOnGround) player.jumpCount = 0;

            // Detect double jump: player jumps while airborne & wasn't jumping before
            if (player.isJumping && !player.lastJumping && !player.isOnGround) {
                player.jumpCount++;
                if (player.jumpCount == 2) {
                    callBack(player); // Execute developer's custom function
                }
            }

            // Store last jumping state
            player.lastJumping = player.isJumping;
        });
    }, 1);
}

detectDoubleJumpEvent(player => {
    let legsEquipment = player.getComponent('equippable').getEquipment('Legs')

    if (hasEquipmentArtifact(player, legsEquipment, 'artifacts:cloud_in_a_bottle')) {
        const direction = player.getViewDirection();
        player.applyKnockback({ x: direction.x, z: direction.z }, 0.5)
        player.dimension.spawnParticle("minecraft:egg_destroy_emitter", player.location);
    }
})