import { world } from "@minecraft/server"
import { hasEquipmentArtifact } from '../utils/functions.js'

world.afterEvents.entityHurt.subscribe(ev => {
    let hurtEntity = ev.hurtEntity

    try {
        if (hurtEntity.typeId != 'minecraft:player') { return }

        let chestEquipment = hurtEntity.getComponent('equippable').getEquipment('Chest')

        if (hasEquipmentArtifact(hurtEntity, chestEquipment, 'artifacts:cross_necklace')) {
            hurtEntity?.addEffect('resistance', 20, { amplifier: 10, showParticles: false })
        }

    } catch { }

})