import { world, system, ItemStack } from "@minecraft/server"
import { randomInt } from '../utils/functions.js'

world.afterEvents.entityDie.subscribe(ev => {
    let entity = ev.deadEntity
    let damager = ev.damageSource.damagingEntity

    if (damager?.typeId == 'minecraft:player' && entity.typeId == 'minecraft:cow') {
        if (randomInt(1, 500) == 1) {
            let item = new ItemStack('artifacts:everlasting_beef')
            damager.dimension.spawnItem(item, entity.location)
        }
    }
})

world.afterEvents.itemCompleteUse.subscribe(ev => {
    let item = ev.itemStack
    let player = ev.source

    if (item.typeId == 'artifacts:eternal_steak' || item.typeId == 'artifacts:everlasting_beef') {
        let equippable = player.getComponent('minecraft:equippable')
        let inventory = player.getComponent('minecraft:inventory')

        if (player.matches({ gameMode: 'creative' })) { return }
        //world.sendMessage(inventory.container.emptySlotsCount.toString())
        if (inventory.container.emptySlotsCount == 0) {
            player.dimension.spawnItem(item, player.location)

        } else {
            equippable.setEquipment('Mainhand', item)

        }
    }
})