import { world } from "@minecraft/server"
import { randomInt, hasEquipmentArtifact } from '../utils/functions.js'


world.afterEvents.entityHurt.subscribe(ev => {
    const damager = ev.damageSource.damagingEntity
    const hurtEntity = ev.hurtEntity


    try {
        if (damager.typeId != 'minecraft:player') { return }

        let chestEquipment = damager.getComponent('equippable').getEquipment('Chest')

        if (hasEquipmentArtifact(damager, chestEquipment, 'artifacts:fire_gauntlet')) {
            hurtEntity.setOnFire(8)
        }
    } catch { }

})