import { world } from "@minecraft/server"
import { hasEquipmentArtifact } from '../utils/functions.js'


world.afterEvents.entityDie.subscribe(ev => {
    let deadEntity = ev.deadEntity
    let damager = ev.damageSource.damagingEntity

    try {
        if (damager.typeId != 'minecraft:player') { return }

        let chestEquipment = damager.getComponent('equippable').getEquipment('Chest')

        if (hasEquipmentArtifact(damager, chestEquipment, 'artifacts:golden_hook')) {
            let health = deadEntity.getComponent('health').effectiveMax

            const MAX_XP_ORBS = 30;

            let numberOfXPOrbs = Math.floor(health / 5);

            numberOfXPOrbs = Math.min(numberOfXPOrbs, MAX_XP_ORBS);

            // Summoneamos los orbes(no funca el spawn entity:C)
            for (let i = 0; i < numberOfXPOrbs; i++) {
                deadEntity.runCommand('summon xp_orb');
            }
        }

    } catch { }

})
