import { world } from "@minecraft/server"
import { hasEquipmentArtifact, randomInt } from '../utils/functions.js'


//lucky_scarf
world.beforeEvents.playerBreakBlock.subscribe(async ev => {
    let block = ev.block
    let player = ev.player
    let item = ev.itemStack

    try {
        let chestEquipment = player.getComponent('equippable').getEquipment('Chest')

        if (hasEquipmentArtifact(player, chestEquipment, 'artifacts:lucky_scarf') && block.typeId.includes('ore') && item?.typeId.includes('pickaxe')) {
            await null;

            let fortune = item.getComponent('enchantable').getEnchantment('fortune')
            let oreItem = block.dimension.getEntities({ type: "minecraft:item", maxDistance: 2, location: block.location, closest: 1 })[0]?.getComponent('item').itemStack

            if (fortune) {
                //world.sendMessage(`${oreItem.typeId}`)
                const randomChance = randomInt(1, 10);

                switch (fortune.level) {
                    case 1: {
                        if (randomChance == 1) {
                            block.dimension.spawnItem(oreItem, block.location);
                        } else if (randomChance == 2) {
                            block.dimension.spawnItem(oreItem, block.location);
                            block.dimension.spawnItem(oreItem, block.location);
                        }
                        break;
                    }
                    case 2: {
                        if (randomChance <= 3) {
                            block.dimension.spawnItem(oreItem, block.location);
                        } else if (randomChance <= 6) {
                            block.dimension.spawnItem(oreItem, block.location);
                            block.dimension.spawnItem(oreItem, block.location);
                        }
                        break;
                    }
                    case 3: {
                        if (randomChance <= 5) {
                            block.dimension.spawnItem(oreItem, block.location);
                            block.dimension.spawnItem(oreItem, block.location);
                        }
                        break;
                    }
                    default: break;
                }

            } else {
                // Fortune I: 33% chance to multiply by 2
                if (randomInt(1, 3) == 1) { // 1 in 3 chance
                    block.dimension.spawnItem(oreItem, block.location);
                }
            }


        }
    } catch { }


})