import { world, system, EntityDamageCause } from "@minecraft/server"
import { hasEquipmentArtifact } from '../utils/functions.js'



world.afterEvents.entityHurt.subscribe(ev => {
    const damager = ev.damageSource
    const hurtEntity = ev.hurtEntity


    try {
        if (hurtEntity.typeId != 'minecraft:player') { return }

        let legsEquipment = hurtEntity.getComponent('equippable').getEquipment('Legs')

        if (damager.cause == EntityDamageCause.fire && hasEquipmentArtifact(hurtEntity, legsEquipment, 'artifacts:obsidian_skull') && !hurtEntity.hasTag('artifacts:obsidian_effect')) {
            hurtEntity.addTag('artifacts:obsidian_effect')
            hurtEntity.addEffect('fire_resistance', 20 * 30)
            system.runTimeout(() => {
                hurtEntity.removeTag('artifacts:obsidian_effect')
            }, 20 * 60)
        }

    } catch { }

})

world.afterEvents.playerSpawn.subscribe(ev => {
    const player = ev.player
    if (player.hasTag('artifacts:obsidian_effect')) {
        player.removeTag('artifacts:obsidian_effect')
        //world.sendMessage('Tag removido')
    }
})