import { world } from "@minecraft/server"
import { randomInt, hasEquipmentArtifact } from '../utils/functions.js'

const foodItems = [
    "artifacts:onion_ring",
    "minecraft:apple",
    "minecraft:beetroot",
    "minecraft:beetroot_soup",
    "minecraft:baked_potato",
    "minecraft:bread",
    "minecraft:cake",
    "minecraft:carrot",
    "minecraft:chicken",
    "minecraft:cooked_chicken",
    "minecraft:cooked_cod",
    "minecraft:cooked_mutton",
    "minecraft:cooked_porkchop",
    "minecraft:cooked_rabbit",
    "minecraft:cooked_salmon",
    "minecraft:cooked_beef",
    "minecraft:cookie",
    "minecraft:melon_slice",
    "minecraft:mushroom_stew",
    "minecraft:potato",
    "minecraft:pumpkin_pie",
    "minecraft:raw_beef",
    "minecraft:raw_chicken",
    "minecraft:raw_cod",
    "minecraft:raw_mutton",
    "minecraft:raw_porkchop",
    "minecraft:raw_rabbit",
    "minecraft:raw_salmon",
    "minecraft:rotten_flesh",
    "minecraft:golden_apple",
    "minecraft:enchanted_golden_apple",
    "minecraft:sweet_berries",
    "minecraft:honey_bottle",
    "minecraft:glow_berries",
    "minecraft:chorus_fruit"
];


world.afterEvents.itemCompleteUse.subscribe(ev => {
    let item = ev.itemStack
    let source = ev.source

    //world.sendMessage(item.typeId)
    //let food = item.getComponent('food')
    //world.sendMessage(`${JSON.stringify(food)}`) 
    try {

        let chestEquipment = source.getComponent('equippable').getEquipment('Chest')

        if (hasEquipmentArtifact(source, chestEquipment, 'artifacts:onion_ring') && foodItems.includes(item.typeId)) {

            source.addEffect('haste', 20 * 15, { amplifier: 1, showParticles: false })
        }
    } catch { }

})
