import { world } from "@minecraft/server"
import { hasEquipmentArtifact } from '../utils/functions.js'

world.afterEvents.entityHurt.subscribe(ev => {
    const damager = ev.damageSource.damagingEntity
    const hurtEntity = ev.hurtEntity

    try {
        if (damager.typeId != 'minecraft:player') { return }

        let chestEquipment = damager.getComponent('equippable').getEquipment('Chest')

        if (hasEquipmentArtifact(damager, chestEquipment, 'artifacts:pocket_piston')) {
            let view = damager.getViewDirection()
            hurtEntity.applyKnockback({ x: view.x, z: view.z }, 0.25)
        }
    } catch { }

})
