import { world, system } from "@minecraft/server"
import { randomInt, hasEquipmentArtifact } from '../utils/functions.js'

world.afterEvents.entityHurt.subscribe(ev => {
    let damager = ev.damageSource.damagingEntity
    let hurtEntity = ev.hurtEntity


    try {
        if (hurtEntity.typeId != 'minecraft:player') { return }

        let chestEquipment = hurtEntity.getComponent('equippable').getEquipment('Chest')
        if (hasEquipmentArtifact(hurtEntity, chestEquipment, 'artifacts:shock_pendant') && randomInt(1, 100) <= 25) {
            hurtEntity.dimension.spawnEntity('minecraft:lightning_bolt', damager.location)
            system.runTimeout(() => {
                hurtEntity.extinguishFire()
            }, 5)
        }
    } catch { }



})