import { world } from "@minecraft/server"
import { hasEquipmentArtifact, randomInt } from '../utils/functions.js'

world.afterEvents.entityDie.subscribe(ev => {
    const damager = ev.damageSource.damagingEntity
    const deadEntity = ev.deadEntity

    if (damager?.typeId != 'minecraft:player') { return }

    let headEquipment = damager.getComponent('equippable').getEquipment('Head')
    if (hasEquipmentArtifact(damager, headEquipment, 'artifacts:superstitious_hat')) {
        let entityLocation = deadEntity.location
        let lootEntities = damager.dimension.getEntities({ type: "minecraft:item", maxDistance: 2, location: entityLocation })

        lootEntities.forEach(lootEntity => {
            //33% por cada item dropeado de duplicarlo
            if (randomInt(1, 3) == 1) {
                let lootItem = lootEntity?.getComponent('item').itemStack
                damager.dimension.spawnItem(lootItem, entityLocation)
                //world.sendMessage(blockId)
            }

        })
    }
})