import { world } from "@minecraft/server"
import { randomInt, hasEquipmentArtifact } from '../utils/functions.js'

const minDamage = 2;
const maxDamage = 6;

world.afterEvents.entityHurt.subscribe(ev => {
    let damager = ev.damageSource.damagingEntity
    let hurtEntity = ev.hurtEntity


    try {
        if (hurtEntity.typeId != 'minecraft:player') { return }

        let chestEquipment = hurtEntity.getComponent('equippable').getEquipment('Chest')

        if (hasEquipmentArtifact(hurtEntity, chestEquipment, 'artifacts:thorn_pendant') && randomInt(1, 100) <= 25) {
            const damage = randomInt(minDamage, maxDamage);
            damager.applyDamage(damage);
        }
    } catch { }

})
