import { world, system } from "@minecraft/server";
import { hasEquipmentArtifact } from '../utils/functions.js'

system.runInterval(() => {
    let players = world.getAllPlayers()
    players.forEach(player => {
        let legsEquipment = player.getComponent('equippable').getEquipment('Legs')

        if (hasEquipmentArtifact(player, legsEquipment, 'artifacts:universal_attractor')) {
            let entities = player.dimension.getEntities({ location: player.location, maxDistance: 8, type: 'minecraft:item' });
            entities.forEach(entity => {
                if (entity) {
                    // Calcula las diferencias de distancia
                    let dx = player.location.x - entity.location.x;
                    let dy = player.location.y - entity.location.y;
                    let dz = player.location.z - entity.location.z;

                    // Calcula la magnitud del vector para normalizar la direccion
                    let magnitude = Math.sqrt(dx * dx + dy * dy + dz * dz);

                    // Normaliza la dirección
                    let normalizedDx = magnitude === 0 ? 0 : dx / magnitude;
                    let normalizedDy = magnitude === 0 ? 0 : dy / magnitude;
                    let normalizedDz = magnitude === 0 ? 0 : dz / magnitude;

                    let strength = 0.25
                    normalizedDx *= strength
                    normalizedDy *= strength
                    normalizedDz *= strength

                    // Aplica el empuje a la entidad
                    entity.clearVelocity();
                    entity.applyImpulse({ x: normalizedDx, y: normalizedDy, z: normalizedDz });
                }
            })
        }
    })
}, 1)