import { world } from "@minecraft/server"
import { randomInt, hasEquipmentArtifact } from '../utils/functions.js'



world.afterEvents.entityHurt.subscribe(ev => {
    let damager = ev.damageSource.damagingEntity
    let hurtEntity = ev.hurtEntity

    try {
        if (hurtEntity.typeId != 'minecraft:player') { return }

        let chestEquipment = hurtEntity.getComponent('equippable').getEquipment('Chest')

        if (hasEquipmentArtifact(hurtEntity, chestEquipment, 'artifacts:vampiric_glove')) {
            const damage = ev.damage
            const healthComponent = damager.getComponent('health')
            const currentHealth = healthComponent.currentValue
            healthComponent.setCurrentValue(currentHealth + damage * 0.2)

        }
    } catch { }

})
