import { world, ItemStack } from "@minecraft/server"
import { hasEquipmentArtifact } from '../utils/functions.js'

world.afterEvents.itemUse.subscribe(ev => {
    const item = ev.itemStack
    const source = ev.source

    if (item.typeId != 'minecraft:ender_pearl') { return }
    const equippable = source.getComponent('equippable')
    const legsEquipment = equippable.getEquipment('Legs')

    if (hasEquipmentArtifact(source, legsEquipment, 'artifacts:warp_drive')) {
        //world.sendMessage('when enderpearl')
        let enderPearl = equippable.getEquipment('Mainhand')
        if (enderPearl) {
            enderPearl.amount += 1
            equippable.setEquipment('Mainhand', enderPearl)
        } else {
            equippable.setEquipment('Mainhand', new ItemStack('minecraft:ender_pearl'))
        }
    }

})