import { world } from "@minecraft/server"
import { randomInt, hasEquipmentArtifact } from '../utils/functions.js'


world.afterEvents.entityHurt.subscribe(ev => {
    let hurtEntity = ev.hurtEntity

    try {
        if (hurtEntity.typeId != 'minecraft:player') { return }

        let headEquipment = hurtEntity.getComponent('equippable').getEquipment('Head')

        if (randomInt(1, 100) <= 5 && hasEquipmentArtifact(hurtEntity, headEquipment, 'artifacts:whoopee_cushion')) {
            const { dimension, location } = hurtEntity
            dimension.playSound('whoopee_cushion.fart', location, { pitch: 0.7 })
        }
    } catch { }

})

world.afterEvents.playerButtonInput.subscribe(ev => {
    let player = ev.player
    let button = ev.button
    let buttonState = ev.newButtonState

    let headEquipment = player.getComponent('equippable').getEquipment('Head')
    if (button == 'Sneak' && buttonState == 'Pressed' && hasEquipmentArtifact(player, headEquipment, 'artifacts:whoopee_cushion') && randomInt(1, 100) <= 10) {
        const { dimension, location } = player
        dimension.playSound('whoopee_cushion.fart', location, { pitch: randomInt(8, 12) / 10 })
    }
})
