import { world } from "@minecraft/server"
import { randomInt, hasEquipmentArtifact } from '../utils/functions.js'


world.afterEvents.entityHurt.subscribe(ev => {
    let damager = ev.damageSource.damagingEntity
    let hurtEntity = ev.hurtEntity

    try {
        if (damager.typeId != 'minecraft:player') { return }

        let chestEquipment = damager.getComponent('equippable').getEquipment('Chest')

        if (hasEquipmentArtifact(damager, chestEquipment, 'artifacts:withered_bracelet') && randomInt(1, 100) <= 30) {
            hurtEntity?.addEffect('wither', 20 * 5, { amplifier: 0, showParticles: true })
        }
    } catch { }

})