import { world, system } from "@minecraft/server"

const artifactsLoreConfig = {
    "artifacts:antidote_vessel": "§r§7Reduces the duration of negative effects",
    "artifacts:eternal_steak": "§r§7Not consumed when eaten",
    "artifacts:everlasting_beef": "§r§7Not consumed when eaten",
    "artifacts:crystal_heart": "§r§7Increases the wearer's max health",
    "artifacts:pocket_piston": "§r§7Increases knockback dealt by the wearer",
    "artifacts:golden_hook": "§r§7Increases experience dropped by creatures",
    "artifacts:chorus_totem": "§r§7Teleports you on fatal hits instead",
    "artifacts:pocket_piston": "§r§7Increases knockback dealt by the wearer",
    "artifacts:flame_pendant": "§r§7Chance to set attackers on fire",
    "artifacts:fire_gauntlet": "§r§7Melee attacks deal fire damage",
    "artifacts:panic_necklace": "§r§7Increases movement speed after damage",
    "artifacts:cross_necklace": "§r§7Increases invincibility after damage",
    "artifacts:onion_ring": "§r§7Boosts mining speed after eating food",
    "artifacts:pickaxe_heater": "§r§7Automatically smelts mined ores",
    "artifacts:shock_pendant": "§r§7Chance to strike attackers with lightning",
    "artifacts:charm_of_sinking": "§r§7Allows free movement in water",
    "artifacts:charm_of_shrinking": "§r§7Shrinks the wearer",
    "artifacts:helium_flamingo": "§r§7Allows player to swim briefly through air",
    "artifacts:plastic_drinking_hat": "§r§7Increases the wearer's saturation",
    "artifacts:novelty_drinking_hat": "§r§7Increases the wearer's saturation",
    "artifacts:warp_drive": "§r§7Prevents ender pearl consumption, costs hunger",
    "artifacts:strider_shoes": "§r§7Allows player to stand on lava while sneaking",
    "artifacts:withered_bracelet": "§r§7Has a chance to apply wither effect on attack",
    "artifacts:cloud_in_a_bottle": "§r§7Allows double jump",
    "artifacts:thorn_pendant": "§r§7Chance to damage attackers",
    "artifacts:obsidian_skull": "§r§7Grants temporary immunity",
    "artifacts:snorkel": "§r§7Allows the wearer to breathe underwater",
    "artifacts:villager_hat": "§r§7Decreases the trading prices of villagers",
    "artifacts:night_vision_goggles": "§r§7Allows the wearer to see in the dark",
    "artifacts:umbrella": "§r§7Slow your fall when held",
    "artifacts:superstitious_hat": "§r§7Applies an extra level of looting",
    "artifacts:cowboy_hat": "§r§7Increases the speed of ridden mounts",
    "artifacts:anglers_hat": "§r§7Applies an extra level of luck of sea and lure",
    "artifacts:lucky_scarf": "§r§7Applies an extra level of fortune",
    "artifacts:scarf_of_invisibility": "§r§7Turns the wearer invisible",
    "artifacts:universal_attractor": "§r§7Attracts nearby items",
    "artifacts:digging_claws": "§r§7Increases the wearer's mining speed",
    "artifacts:feral_claws": "§r§7Increases the wearer's damage attack",
    "artifacts:power_glove": "§r§7Increases damage dealt by the wearer",
    "artifacts:vampiric_glove": "§r§7Causes the wearer's attacks to absorb health",
    "artifacts:aqua_dashers": "§r§7Allows the wearer to walk on fluids",
    "artifacts:bunny_hoppers": "§r§7Increases jump",
    "artifacts:kitty_slippers": "§r§7Creepers avoid the wearer",
    "artifacts:running_shoes": "§r§7Increases the wearer's movement speed",
    "artifacts:snowshoes": "§r§7Allows the wearer to walk on powder snow",
    "artifacts:steadfast_spikes": "§r§7Grants inmunity to knockback",
    "artifacts:flippers": "§r§7Improves agility in water",
    "artifacts:rooted_boots": "§r§7Slowly restores hunger while walking on grass",
    "artifacts:whoopee_cushion": "§r§7Increases the wearer's flatulence"
}

function artifactsAddLore(container, slot, item) {
    const lore = item.getLore()
    const newLore = artifactsLoreConfig[item.typeId]
    if (!newLore) { return };
    const newItem = item.clone();

    //novelty api le añade lore a nuestro item por eso debemos hacer esta verificacion
    if (lore.length < 2 && !lore[0]?.startsWith('§r§7')) {
        lore.push(newLore)
        newItem.setLore(lore);
        container.setItem(slot, newItem);
    }
}



system.runInterval(() => {
    const players = world.getAllPlayers()
    players.forEach(player => {
        const inventory = player.getComponent("inventory");
        const container = inventory.container;
        for (let i = 0; i < inventory.inventorySize; i++) {
            const item = container.getItem(i);
            if (!item) continue;
            artifactsAddLore(container, i, item);
        }

    })
}, 20)

/*En caso el item no tenga lore te convendria usar este sistema

const loreConfig = {
    "minecraft:stick": [
        "§r§1Slot: Charm",
        "§r§7Increases the wearer's maximum health"
    ]
}
function addLore(container, slot, item) {
    const lore = loreConfig[item.typeId]
    if (!lore) { return };
    if (item.getLore().length > 0) { return };
    const newItem = item.clone();

    newItem.setLore(lore);
    container.setItem(slot, newItem);
}

system.runInterval(() => {
    const players = world.getAllPlayers()
    players.forEach(player => {
        const inventory = player.getComponent("inventory");
        const container = inventory.container;
        for (let i = 0; i < inventory.inventorySize; i++) {
            const item = container.getItem(i);
            if (!item) continue;
            addLore(container, i, item);
        }

    })
}, 20)

 */