import { world } from "@minecraft/server";
import { randomInt } from "./utils/functions";

const mobEquipment = {
    "minecraft:wither_skeleton": [
        {
            slot: "slot.armor.legs",
            item: "artifacts:antidote_vessel"
        },
        {
            slot: "slot.armor.chest",
            item: "artifacts:fire_gauntlet"
        }
    ],
    "minecraft:skeleton": [
        {
            slot: "slot.armor.chest",
            item: "artifacts:flame_pendant"
        },
        {
            slot: "slot.armor.head",
            item: "artifacts:night_vision_goggles"
        },
        {
            slot: "slot.armor.head",
            item: "artifacts:plastic_drinking_hat"
        }
    ],
    "minecraft:piglin": [
        {
            slot: "slot.armor.chest",
            item: "artifacts:golden_hook"
        },
        {
            slot: "slot.armor.legs",
            item: "artifacts:universal_attractor"
        },
        {
            slot: "slot.armor.legs",
            item: "artifacts:obsidian_skull"
        }
    ],
    "minecraft:drowned": [
        {
            slot: "slot.armor.head",
            item: "artifacts:snorkel"
        },
        {
            slot: "slot.armor.feet",
            item: "artifacts:flippers"
        }
    ],
    "minecraft:zombie": [
        {
            slot: "slot.armor.head",
            item: "artifacts:cowboy_hat"
        },
        {
            slot: "slot.armor.head",
            item: "artifacts:scarf_of_invisibility"
        }
    ],
    "minecraft:piglin_brute": [
        {
            slot: "slot.armor.chest",
            item: "artifacts:onion_ring"
        }
    ],
    "minecraft:stray": [
        {
            slot: "slot.armor.feet",
            item: "artifacts:steadfast_spikes"
        }
    ],
    "minecraft:husk": [
        {
            slot: "slot.armor.chest",
            item: "artifacts:thorn_pendant"
        },
        {
            slot: "slot.armor.chest",
            item: "artifacts:vampiric_glove"
        }
    ]
};

world.afterEvents.entitySpawn.subscribe(ev => {
    const entity = ev.entity;
    const equipmentList = mobEquipment[entity.typeId];

    try {
        if (equipmentList && randomInt(1, 100) <= 3) {
            const randomEquipment = equipmentList[randomInt(0, equipmentList.length - 1)];
            entity.runCommand(`replaceitem entity @s ${randomEquipment.slot} 0 ${randomEquipment.item}`);
        }
    } catch { }

});